using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;

namespace ConsoleApplication1
{
    /// <summary>
    /// Creating a Class Buffer that contains a Queue that represent the "Parking lot".
    /// The Queue is limited by the size that can manually be setted
    /// </summary>
    
    public class Buffer
    {
        private Queue<Car> carQueue;
        private int size = 10;
        private Mutex mutex;

        public Buffer()
        {
            mutex = new Mutex();
            carQueue = new Queue<Car>();
        }

        public void push(Car c)
        {
            if (carQueue.Count == size)
            {
                throw new Exception("Buffer full");
            }
            
            
            carQueue.Enqueue(c);
        }

        public Car pop()
        {
            if (carQueue.Count == 0)
            {
                throw new Exception("Buffer empty");
            }

            return carQueue.Dequeue();
        }

        public bool full()
        {
            bool isFull = false;
            if (carQueue.Count == size)
            {
                isFull = true;
            }

            return isFull;
        }

        public bool empty()
        {
            if (carQueue.Count == 0)
            {
                return true;
            }

            return false;
        }

        public Mutex getMutex()
        {
            return this.mutex;
        }


    }
}
